﻿-- Addon:	ChiBar: GUI-creating part
-- Author:	Rakhan(EU-Azshara)


-- Disables Addons, if Character is no Monk
if select(2, UnitClass("player")) ~= "MONK" then
    return
end



local VERSIONNUMBER = GetAddOnMetadata("ChiBar", "Version")


------------------------------------------
--		Creating Varibales 				--
------------------------------------------

-- Creating MainArray for all da fun, mon!
ChiBar = {}
-- Creating MainFrame
ChiBar.mainFrame = CreateFrame("Frame", "ChiBarFrame", UIParent)
-- Some Constants
local ICON = "|TINTERFACE\\PlayerFrame\\MonkLightPower:15:15|t"
ChiBar.VERSIONTEXT = ICON.."|cff00FF96ChiBar Version "..VERSIONNUMBER.." -- Rakhan(EU-Azshara)"..ICON
ChiBar.TEXTURE_NAMES = {"Ying & Yang", "Minimalistic", "Chinese Dragon",}
ChiBar.textures = {}
local index = 1
for index = 1, #ChiBar.TEXTURE_NAMES do
	ChiBar.textures[((index*2)-1)] = "Interface\\Addons\\ChiBar\\images\\empty"..index..".tga"
	ChiBar.textures[(index*2)] = "Interface\\Addons\\ChiBar\\images\\glow"..index..".tga"
end


------------------------------------------
--		GUI								--
------------------------------------------

function ChiBar:createUI()
	-- Creating SubFrame
	ChiBar.Bubbles = {}
	for index = 1, 5 do
		ChiBar.Bubbles[index] = CreateFrame("Frame", "ChiBubble1"..index, ChiBar.mainFrame)
	end

	-- Creating Textures
	ChiBar.BGTexture = ChiBar.mainFrame:CreateTexture("BGTexture", "BACKGROUND")
	ChiBar.BGTexture2 = ChiBar.Bubbles[1]:CreateTexture("BGTexture2", "OVERLAY")
	ChiBar.BGTexture:SetTexture(220, 220, 220, 0.3)
	ChiBar.BGTexture2:SetTexture(250, 250, 250, 0.7)
	ChiBar.BGTexture2:SetAllPoints(ChiBar.mainFrame)
	ChiBar.BGTexture:Hide()
	ChiBar.BGTexture2:Hide()
	ChiBar.Textures0 = {}
	ChiBar.Textures1 = {}
	for index = 1, 5 do
		ChiBar.Textures0[index] = ChiBar.Bubbles[index]:CreateTexture("ChiTexture"..index.."0")
		ChiBar.Textures1[index] = ChiBar.Bubbles[index]:CreateTexture("ChiTexture"..index.."1")
		ChiBar.Textures0[index]:SetDrawLayer("ARTWORK", 6)
		ChiBar.Textures1[index]:SetDrawLayer("ARTWORK", 7)
	end
	
	-- Orientation
	ChiBar:settingUpOrientation()
	
	-- Setting proberties of the mainFrames
	ChiBar.mainFrame:SetWidth(64)
	ChiBar.mainFrame:SetHeight(64)
	ChiBar.mainFrame:SetPoint(ChiBarDB.from, UIParent, ChiBarDB.to, ChiBarDB.x, ChiBarDB.y)
	ChiBar.mainFrame:SetScale(ChiBarDB.scale)
	ChiBar.mainFrame:SetAlpha(ChiBarDB.alpha)
	ChiBar.mainFrame:RegisterForDrag("LeftButton")
	ChiBar.mainFrame:SetMovable(false)

	-- Setting proberties of the subFrames
	for index = 1, 5 do
		ChiBar.Bubbles[index]:SetHeight(64)
		ChiBar.Bubbles[index]:SetWidth(64)
	end	
	
	-- Setting proberties of the Frames
	for index = 1, 5 do
		ChiBar.Textures0[index]:SetAllPoints(ChiBar.Bubbles[index])
		ChiBar.Textures1[index]:SetAllPoints(ChiBar.Bubbles[index])
		ChiBar.Textures0[index]:SetTexture(ChiBar.textures[((ChiBarDB.savedTexture*2)-1)])
		ChiBar.Textures1[index]:SetTexture(ChiBar.textures[(ChiBarDB.savedTexture*2)])
		ChiBar.Textures1[index]:Hide()
	end
end

-- Set the orientation of ChiBar
function ChiBar:settingUpOrientation()
	if ChiBarDB.grow1 then
		ChiBar.BGTexture:SetWidth(320)
		ChiBar.BGTexture:SetHeight(64)
		ChiBar.orientation1 = 0
		if ChiBarDB.grow2 then
			ChiBar.orientation2 = 1
		else
			ChiBar.orientation2 = -1
		end
	else
		ChiBar.BGTexture:SetWidth(64)
		ChiBar.BGTexture:SetHeight(320)
		ChiBar.orientation1 = 1
		if ChiBarDB.grow2 then	
			ChiBar.orientation2 = 1
		else
			ChiBar.orientation2 = -1
		end
	end
	
	local add = 0
	if UnitPowerMax("player", 12) == 4 then add = 32 end
	
	ChiBar.BGTexture:SetPoint("CENTER", ChiBar.Bubbles[3], "CENTER", (-add)*(1-ChiBar.orientation1)*ChiBar.orientation2, (-add)*ChiBar.orientation1*ChiBar.orientation2)
	for index = 0, 4 do
		local coord = (index*64+add)*ChiBar.orientation2
		ChiBar.Bubbles[index+1]:SetPoint("CENTER", ChiBar.mainFrame, "CENTER", coord*(1-ChiBar.orientation1), coord*ChiBar.orientation1)
	end
end


------------------------------------------
--		End of Script					--
------------------------------------------